/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceTrianglesMaya_h__
#define __surface_SurfaceTrianglesMaya_h__

namespace fe
{

/**************************************************************************//**
	@brief Maya Trianglar Surface

	@ingroup maya
*//***************************************************************************/
class FE_DL_EXPORT SurfaceTrianglesMaya: public SurfaceTriangles
{
	public:
							SurfaceTrianglesMaya(void);
virtual						~SurfaceTrianglesMaya(void);

							//* As Protectable
virtual	Protectable*		clone(Protectable* pInstance=NULL);

							//* Maya specific
	void					setMeshObject(const MObject a_meshObject)
							{	m_meshObject=a_meshObject; }
const	MObject					meshObject(void)
							{	return m_meshObject; }

	protected:

virtual	void				cache(void);

	private:

		MObject				m_meshObject;
};

} // namespace

#endif /* __surface_SurfaceTriangles_h__ */

