/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_SurfaceBindOp_h__
#define __operator_SurfaceBindOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to correlate a attachable surface with a driving surface

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT SurfaceBindOp:
	public OperatorThreaded,
	public Initialize<SurfaceBindOp>
{
	public:

					SurfaceBindOp(void)										{}
virtual				~SurfaceBindOp(void)									{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

					// TODO
virtual	void		run(I32 a_id,sp<SurfaceRange> a_spRange)				{}

	protected:
		String		getSignature(sp<SurfaceAccessibleI>& a_rspAccessibleI);
		void		setSignature(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							String a_signature);

		I32			accessBindings(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							std::vector< sp<SurfaceAccessorI> >&a_rFaces,
							std::vector< sp<SurfaceAccessorI> >&a_rBarys,
							BWORD a_allowCreation);
};

} /* namespace */

#endif /* __operator_SurfaceBindOp_h__ */
